<html>
<head>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
<script type="text/javascript" src="jquery-1.10.2.js"></script>
<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
<script type="text/javascript" src="calculationlib/polynomial.js"></script>
<script type="text/javascript" src="calculationlib/mathhelper.js"></script>

<style>
.edit-text {
  display: none;
}
.label-g .mathtex {
  float: left;
}
.mathtex {
  padding: 5px;
}
td {
  padding: 5px;
}
</style>

<script>







var CreateInput = function(inputCount) {

  var text = "<hr><h3>Sırrı Çözme</h3>";
  text += "<div id='divFindSecretParams'>";
  text += "<div id='divSecretInputs'>";
  text += "<table>"
  text += "<tr>";
  for (var i = 1; i < inputCount+1; i++)
    text += "<td align='center'>" + i + "</td>";
  text += "</tr>";
  text += "<tr>";
  for (var i = 1; i < inputCount+1; i++)
    text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
  text += "</tr>";
  text += "</table>";
  text += "</div>";
  text += "<input type='button' class='findscrt' id='btnFindSecret' value='Sırrı Bul' />";
  text += "</div>";
  text += "<div id='divSecretResult'> </div>";
  return text;
}
var FieldExtend = function(gp){
  $this = this;
  $this.GenPoly = gp;
  $this.GenPolyPow = gp.Data.length - 1;
  $this.Root = new Polynomial(gp.Data.slice(1), gp.Degree, "\\theta").Multiply(gp.Degree.Inverse(gp.Data[0]), "\\theta");
  $this.Degree = gp.Degree;

  var generatePolynomPow = function(p, c) {
      var data = [];
      c = c || 1;
      data.push(c);
      for (var i = 0; i < p; i++)
        data.push(0);
      return new Polynomial(data, gp.Degree, "\\theta");
    }
  var reduce = function(poly, rootDegree, root) { // x^255, 8, \\theta+1
      if (poly.Data.length - 1 < rootDegree)
        return poly;
      var lowerPart = new Polynomial(poly.Data.slice(poly.Data.length - rootDegree, poly.Data.length), gp.Degree, "\\theta");
      var list = [lowerPart];
      for (var i = 0; i < poly.Data.length - rootDegree; i++){
        var pw = poly.Data.length - i - 1;
        var r = pw % rootDegree;
        var b = parseInt(pw / rootDegree);
        if (poly.Data[i] == 0)
          continue;
		    var coef = poly.Data[i];
        var rp = generatePolynomPow(r);
        var resp = root.Pow(b, "\\theta").Multiply(coef, "\\theta").Multiply(rp, "\\theta");
        if (resp.Data.length - 1 >= rootDegree)
          resp = reduce(resp, rootDegree, root);
        list.push(resp);
      }
      var result = new Polynomial([0], gp.Degree, "\\theta" );
      for (var i = 0; i < list.length; i++) {
        result = result.Add(list[i], "\\theta");
      }
      if (result.Data.length - 1 >= rootDegree)
        result = reduce(result, rootDegree, root);
      return result;
    }
  $this.Get = function(pow) {
    var poly = generatePolynomPow(pow);
    return poly;
  }
  $this.GetElementPow = function(pow) {
    var poly = generatePolynomPow(pow);
    poly = reduce(poly, this.GenPolyPow, this.Root);
    return poly;
    //var r = pow % $this.GenPolyPow;
    //var b = parseInt(pow / $this.GenPolyPow);
    //return { Text: (b > 0 ? "(" + $this.Root.Text + ")^{" + b + "}" : "") + (r > 0 ?" \\theta^{" + r + "}" : "")   };
    return this.Root.Pow(2, "\\theta");
  }
  $this.Reduce = function(poly) {
	  return reduce(poly, this.GenPolyPow, this.Root);
  }
};
var TransferFunction = function(fieldExtend) {
  $this = this;
  $this.Field = fieldExtend;
  $this.Level = Math.pow(this.Field.Degree.Value, this.Field.GenPolyPow);



  $this.Info = function(){
    var transferfunction =
      'T(x) =' +
      '\\left\\{' +
      '\\begin{array}{ll}' +
      '0,        & x \\equiv 0 \\pmod{' + $this.Level + '} \\text{ ise} \\\\' +
      '\\theta^x, & x \\not\\equiv 0 \\pmod{' + $this.Level + '} \\text{ ise}' +
      '\\end{array}' +
      '\\right.';
    return transferfunction;
  }
  $this.Get = function(value){
    var val = value % this.Level;
    if (val == 0)
      return new Polynomial([0], this.Field.Degree, "\\theta");
    return this.Field.Get(val);
  }
  $this.Calc = function(value){
    var val = value % this.Level;
    if (val == 0)
      return new Polynomial([0], this.Field.Degree, "\\theta");
    return this.Field.GetElementPow(val);
  }
  $this.Text = function(value){
    var val = value % this.Level;
    return '\\theta^{' + val + '}';
  }

  //trf.Calc(1).Data.toString() == trf.Calc(1).Data.toString()
  var data = {};
  var reverse = {};
  for (var i = 0; i < $this.Level; i++) {
    var val = $this.Calc(i);
    data[i] = val;
    reverse[val.Data.toString()] = i;
  }

  $this.Reverse = function(polynom){
    return reverse[polynom.Data.toString()];
  }
};

var mthhlp = new mathhelper();
var fld;
var trf;

$(document).ready(function() {
  $('a.edit').click(function() {
    var t = $(this).parent();  // div
	  var l = t.find('.lab');    // label
    var value = l.attr("data-value").trim();
    l.hide();
    t.find('.edit').hide();
	  t.find('.edit-text').show().focus().val(value);
  });
  $('.label-g .edit-text').focusout(function() {
    var t = $(this).parent();
	  $(this).hide();
    var mode = $(this).attr("value-mode");
    var deg = parseInt(eval($(this).attr("data-degree")));
    var l = t.find('.lab');

    var raw =  $(this).val();
    var result = raw;
    if (mode == "polynom") {
      var data = mthhlp.read.polynomial(raw);
      var poly = new Polynomial(data, deg);
      result = poly.Text;
      $(this).attr("data-polynom", poly);
    }
    else if (mode == "matrix") {
      var data = mthhlp.read.matrix(raw);
      var matrix = new Matrix(data);
      result = matrix.ToLatex();
      $(this).attr("data-matrix", matrix);
    }
    l.attr("data-value", raw);
    mthhlp.out.clear(l);
    mthhlp.out.write(l, result);
    l.show();
    t.find('.edit').show();
  });
  $('.label-g .edit-text').trigger('focusout');

  $('#elDegree .edit-text').on('focusout', function() {
	$('#elPolynomial .edit-text').trigger('focusout');
  });
  $('#btnCalculateField').on('click', function() {
    var degree = parseInt($("#elDegree .edit-text").val());
    var genPoly = new Polynomial(mthhlp.read.polynomial($("#elPolynomial .edit-text").val()), degree);
    var fieldExtend = new FieldExtend(genPoly);
    fld = fieldExtend;


    var n = parseInt($("#elN .edit-text").val());
    var k = parseInt($("#elK .edit-text").val());
    var s = parseInt($("#elSecret .edit-text").val());

    var result = $("#result");

    mthhlp.out.clear(result);

    mthhlp.out.write(result, "\\theta^{" + fieldExtend.GenPolyPow + "}=" + fieldExtend.Root.Text);
    //mthhlp.out.write(result, "\\theta^{" + 63 + "} = " + fieldExtend.GetElementPow(63).Text);
    mthhlp.out.write(result, " ");

    var level = Math.pow(fieldExtend.Degree.Value, fieldExtend.GenPolyPow);
    var tf = new TransferFunction(fieldExtend);
    trf = tf;

    mthhlp.out.write(result, tf.Info());
    mthhlp.out.write(result, " ");

    mthhlp.out.write(result, 'T(s) = T(' + s + ')=' + tf.Text(s) + '=(' + tf.Calc(s).Text + ')');
    mthhlp.out.write(result, " ");



    var degreeOfPolynomial = k - 1;
    var polynomArray = [];
    for (var i = 0; i < degreeOfPolynomial; i++)
      polynomArray.push(parseInt(Math.random() * level));
    polynomArray.push(s);
    while (polynomArray[0] == 0)
      polynomArray[0] = parseInt(Math.random() * level);
    var polynom = new Polynomial(polynomArray, level);

    var polyarray = [];
    for (var i = 0; i < polynomArray.length; i++){
      polyarray.push(tf.Calc(polynomArray[i]));
    }
    var poly = new Polynomial(polyarray)
    var txt = poly.Text;

    var polynomText = "f(" + polynom.Symbol + ")=";
    polynomText += polynom.Text + "=" + txt;
    mthhlp.out.write(result, polynomText);
    mthhlp.out.write(result, " ");


    var shareText = "\\begin{array}{lllll}";
    for (var i = 1; i <= n; i++) {
      var val = tf.Calc(i);
      var res = fieldExtend.Reduce(poly.Calculate(val));
      var numval = tf.Reverse(res);
      shareText += "T^{-1}(f(T(" + i + "))) & =" + "T^{-1}(f(" + tf.Text(i) + "))" + " & =T^{-1}(f(" + val.Text + ")) &= T^{-1}(" + res.Text + ") &=T^{-1}(\\theta^{" + numval + "}) &= \\textbf{" + numval + "}\\\\";
    }
    shareText += "\\end{array}";
    mthhlp.out.write(result, shareText);
    mthhlp.out.write(result, " ");

    var inputs = CreateInput(n);
    $("#reconstuct").html(inputs);
    $('.findscrt').on('click', function() {
      var findresult = $("#divSecretResult");
      //$("#divSecretResult").append("<h4>Birinci Yöntem</h4>");
      var text1 = "L(x)=\\sum_{j=0}^{k}{y_jl_j(x)} \\\\ ";
      //text1 += "l_j(x)=\\prod_{\\begin{array}{c}0 \\leq m \\leq k \\\\ m \\neq j \\end{array}}{\\frac{x-x_m}{x_j-x_m}}";
      text1 += "l_j(x)=\\prod_{\\begin{array}{c}0 \\leq m \\leq k \\\\ m \\neq j \\end{array}}{\\frac{x-x_m}{x_j-x_m}}";
      mthhlp.out.clear(findresult);
      mthhlp.out.write(findresult, text1);
      mthhlp.out.write(findresult, "");

      var pairs = [];
      $("[id^=txtInpt]").each(function() {
        if (!isNaN(parseInt($(this).val())))
          pairs.push([parseInt($(this).attr('num')), parseInt($(this).val())]);
      });

      L = [];
      for (var k = 0; k < pairs.length; k++){
        var text = "", text1 = "", text2 = "", text3 = "", text4 = "";

        var polyarray = [ new Polynomial([1], fieldExtend.Degree, "\\theta") ];
        var polynom = new Polynomial(polyarray)
        for (var i = 0; i < pairs.length; i++) {
          if (k == i) continue;
          var xk = tf.Calc(pairs[k][0]);
          var xi = tf.Calc(pairs[i][0]);
          var divider = xk.Add(xi.Multiply(-1));
          var dividerpow = tf.Reverse(divider);
          var inversepow = tf.Level-1 != dividerpow ? tf.Level - dividerpow - 1 : dividerpow;
          var inverse = tf.Calc(inversepow);

          var subpolyarray =
          [
            new Polynomial([1], fieldExtend.Degree, "\\theta"),
            xi.Multiply(-1)
          ];
          var p = new Polynomial(subpolyarray);
          p = p.Multiply(inverse);

          text1 += "\\displaystyle{\\frac{(x-(" + xi.Text + "))}{(" + xk.Text + "-(" + xi.Text + "))}}";
          text2 += "\\displaystyle{\\frac{(x-(" + xi.Text + "))}{(" + "\\theta^{" + dividerpow + "}" + ")}}";
          text3 += "[(x-" + xi.Text + ")" + "\\theta^{" + inversepow + "}" + "]";
          text4 += "[(x-" + xi.Text + ")(" + inverse.Text + ")]";
          //text3 += "(" + p.Text + ")";
          polynom = polynom.Multiply(p);
          var reducedarray = [];
          for (var j = 0; j < polynom.Data.length; j++)
            reducedarray.push(fieldExtend.Reduce(polynom.Data[j]));
          polynom = new Polynomial(reducedarray);
        }
        text += "\\begin{array}{ll}";
        text += "l_{" + pairs[k][0] + "}(x) &=" + text1 + "\\\\";
        text += "&=" + text2 + "\\\\";
        text += "&=" + text3 + "\\\\";
        text += "&=" + text4 + "\\\\";
        text += "&=" + polynom.Text + "\\\\";
        text += "\\end{array}";
        mthhlp.out.write(findresult, text);
        mthhlp.out.write(findresult, "");
        L.push(polynom);
      }


      var result = new Polynomial([new Polynomial([0], fieldExtend.Degree, "\\theta")]);
      var text  = "\\begin{array}{ll} L(x)=&";
      var text2 = "\\begin{array}{ll} L(x)=&";
      var text3 = "\\begin{array}{ll} L(x)=&";
      for (var i = 0; i < L.length; i++) {
        var val = tf.Calc(pairs[i][1]);

        var mp = L[i].Multiply(val);

        var tab = "";
        if (i != 0)
          tab = "&+";
        text += tab + "(" + val.Text + ")[" + L[i].Text + "]\\\\";
        text2 += tab + "(" + mp.Text + ")\\\\";

        var reducedarray = [];
        for (var j = 0; j < mp.Data.length; j++)
          reducedarray.push(fieldExtend.Reduce(mp.Data[j]));
        mp = new Polynomial(reducedarray);
        text3 += tab + "(" + mp.Text + ")\\\\";

        result = result.Add(mp);
      }

      var reducedarray = [];
      for (var j = 0; j < result.Data.length; j++)
        reducedarray.push(fieldExtend.Reduce(result.Data[j]));
      result = new Polynomial(reducedarray);

      var text4 = "L(x)=" + result.Text;
      mthhlp.out.write(findresult, text + "\\end{array}");
      mthhlp.out.write(findresult, "");
      mthhlp.out.write(findresult, text2 + "\\end{array}");
      mthhlp.out.write(findresult, "");
      mthhlp.out.write(findresult, text3 + "\\end{array}");
      mthhlp.out.write(findresult, "");
      mthhlp.out.write(findresult, text4);
      mthhlp.out.write(findresult, "");

      var dataarray = [];
      for (var j = 0; j < result.Data.length; j++)
        dataarray.push(tf.Reverse(result.Data[j]));
      result = new Polynomial(dataarray);
      mthhlp.out.write(findresult, "L(x)=" + result.Text );
      mthhlp.out.write(findresult, "");
      mthhlp.out.write(findresult, "s = L(0)=" + result.Calculate(0) );
    })
  });

});

</script>

</head>
<body>


<table>
  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Cisim Derecesi (\(q\)): </label>
    </td>
    <td>
      <div class="label-g" id="elDegree">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "2" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Üreteç Polinom (\(f(x)\)): </label>
    </td>
    <td>
      <div class="label-g" id="elPolynomial">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value="x^8 +x^4+x^3+x^2+1" value-mode="polynom" data-degree="$('#elDegree .edit-text').val()"/>
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Katılımcı Sayısı (\(n\)): </label>
    </td>
    <td>
      <div class="label-g" id="elN">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "10" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Eşik Değeri (\(k\)): </label>
    </td>
    <td>
      <div class="label-g" id="elK">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "3" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Sır (\(s\)): </label>
    </td>
    <td>
      <div class="label-g" id="elSecret">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "150" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr style="display: none;">
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Üreteç Matris (\(G\)): </label>
    </td>
    <td>
      <div class="label-g">
      <label for="elab" class="lab"></label>
      <textarea class="edit-text" id = "elab" rows="5" value-mode="matrix" data-degree="2">
        1 1 1 1 1 1 1
        1 0 0 0 1 0 1
        1 1 0 0 0 1 0
        0 1 1 0 0 0 1
      </textarea>
      <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>
</table>

<input type="button" id="btnCalculateField" value="Hesapla" />

<div id="result"  style="padding: 20px"> </div>

<div id="reconstuct" style="padding: 20px"> </div>


</body>
</html>
